unit Unit1;

//+-----------------------------------------------------------------------------+
//+TKS Software                                                                 +
//+Demo de Utilizao da NFPaulista32Dll.dll sem Banco de Dados                 +
//+                                                                             +
//+ Demonstra e implementa a comunicao entre o aplicativo e a dll para a      +
//+gerao do arquivo magntico da NFPaulista atravs da declarao e           +
//+chamada de todas as funes e registros disponveis na verso.               +
//+                                                                             +
//+ Para informaes e atualizaes do produtos acesse:                         +
//+ http://www.igara.com.br/produto.php?cod_produto=112                         +
//+-----------------------------------------------------------------------------+


//+-----------------------------  IMPORTANTE -----------------------------------+
//+                                                                             +
//+ Para valores numricos maiores que 1000, o mesmo deve ser passado para as   +
//+funes sem o separador de casas de milhar.                                  +
//+Exemplo:                                                                     +
//+ 1.000,00 deve ser passado como 1000,00                                      +
//+                                                                             +
//+-----------------------------------------------------------------------------+

interface

uses
  ShareMem, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Dateutils, ExtCtrls, ComCtrls, jpeg, Menus, ShellApi,
  Buttons, RxGIF;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Button7:   TButton;
    TabSheet3: TTabSheet;
    GroupBox6: TGroupBox;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label34: TLabel;
    PopupMenu1:   TPopupMenu;
    PageControl2: TPageControl;
    TabSheet4:  TTabSheet;
    Panel2: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1:  TEdit;
    Edit2:  TEdit;
    Panel3:    TPanel;
    Panel1:    TPanel;
    GroupBox1: TGroupBox;
    Label5:    TLabel;
    OpenDialog1: TOpenDialog;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Sequencia203040506090: TMenuItem;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Image5: TImage;
    SairBtn: TButton;
    Label1: TLabel;
    Label4: TLabel;
    Label6: TLabel;
    GroupBox2: TGroupBox;
    Reg10Btn: TButton;
    Reg20Btn: TButton;
    Reg30Btn: TButton;
    Reg40Btn: TButton;
    Reg50Btn: TButton;
    Reg60Btn: TButton;
    Reg90Btn: TButton;
    GroupBox3: TGroupBox;
    Reg10_CAT9807: TButton;
    Reg20_CAT9807: TButton;
    Reg21_CAT9807: TButton;
    Reg22_CAT9807: TButton;
    Reg90_CAT9807: TButton;
    Label7: TLabel;
    Label8: TLabel;

    procedure Trata_NFPaulista_Int(sender: tobject; retorno: integer);

    procedure Reg20BtnClick(Sender: TObject);
    procedure Reg30BtnClick(Sender: TObject);
    procedure Reg40BtnClick(Sender: TObject);
    procedure Reg90BtnClick(Sender: TObject);
    procedure Reg60BtnClick(Sender: TObject);
    procedure Reg50BtnClick(Sender: TObject);
    procedure Reg10BtnClick(Sender: TObject);

    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);

    procedure Sequencia10_20_30_40_50_60_90Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SairBtnClick(Sender: TObject);
    procedure Reg10_CAT9807Click(Sender: TObject);
    procedure Reg20_CAT9807Click(Sender: TObject);
    procedure Reg21_CAT9807Click(Sender: TObject);
    procedure Reg22_CAT9807Click(Sender: TObject);
    procedure Reg90_CAT9807Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  TempInt: Integer;

Const

 CNPJ: String = '34261131000144';               //Preencher a varivel com um CNPJ vlido
 IE:  String =  '0740873800250';                //Preencher a varivel com uma Inscrio Estadual vlida
 UF:  String =  'DF';
 CPF: string =  '80910912572';


 CGC_Nota: String = '';           //Preencher a varivel com um CNPJ vlido
 IE_Nota:  String = 'ISENTO';     //Preencher a varivel com uma Inscrio Estadual vlida
 UF_Nota:  String = 'PE';

implementation
Function Info_Versao: integer; stdcall; external 'NFPaulista32Dll.dll';
Function Inicia_NF_Paulista(Dir_Saida, Dir_Entrada: String): integer; stdcall; external 'NFPaulista32Dll.dll';
Procedure Finaliza_NF_Paulista; stdcall; external 'NFPaulista32Dll.dll';

Function  RemoveAlfaInvalid(FromStr: String): String; stdcall; external 'NFPaulista32Dll.dll';
Function  RemoveNumInvalid(FromStr: String): String; stdcall; external 'NFPaulista32Dll.dll';
Function  IsNFPaulistaDate(Date_Str: String): boolean; stdcall; external 'NFPaulista32Dll.dll';
Function IsNFPaulistaDateTime(Date_Str: String): boolean; stdcall; external 'NFPaulista32Dll.dll';

Function vLeiaute(VER: String): Boolean; stdcall; external 'NFPaulista32Dll.dll';
Function vCST(CST: String): Boolean; stdcall; external 'NFPaulista32Dll.dll';

Function vCEP_UF(cCep:String ; cEstado:String): Boolean; stdcall; external 'NFPaulista32Dll.dll';
Function vUF(UF: String): Boolean; stdcall; external 'NFPaulista32Dll.dll';
Function vCPF(const CPF: String): Boolean; stdcall; external 'NFPaulista32Dll.dll';
Function vCNPJ(const CGC: String): Boolean; stdcall; external 'NFPaulista32Dll.dll';
Function vInd_tipo_frete(IND_FRT: String): Boolean; stdcall; external 'NFPaulista32Dll.dll';
Function vCOD_CFOP(COD_CFOP: String): Boolean; stdcall; external 'NFPaulista32Dll.dll';
Function vCOD_NCM(COD_NCM: String): Boolean; stdcall; external 'NFPaulista32Dll.dll';
Function vFunc_Reg(Func_Reg: string): Boolean; stdcall; external 'NFPaulista32Dll.dll';
Function vxJust(Just ,Func_Reg: string): Boolean; stdcall; external 'NFPaulista32Dll.dll';
Function vtpNF(NF: string): Boolean; stdcall; external 'NFPaulista32Dll.dll';
function vItemNF(Tipo: String): Boolean; stdcall; external 'NFPaulista32Dll.dll';
Function vSerie_NFVC(Serie_NFVC: string): Boolean; stdcall; external 'NFPaulista32Dll.dll';
Function vEntrega_Domicilio(Domicilio: string): Boolean; stdcall; external 'NFPaulista32Dll.dll';
Function vRealiza_Venda_Prazo(Venda: string): Boolean; stdcall; external 'NFPaulista32Dll.dll';
Function vTipo_Receita(Tipo: string): Boolean; stdcall; external 'NFPaulista32Dll.dll';
Function Registro10_CAT10207(COD_VER, CNPJ, DT_INI, DT_FIN: String): Integer; stdcall; external 'NFPaulista32Dll.dll';
Function Registro20_CAT10207(FUNC_REG, xJUST, natOp, serie, nNF, dEmi, dSaiEnt,
                    tpNF, CFOP, IEST, IM, CNPJ, xNome, xLgr, nro,
                    xCpl, xBairro, xMun, UF, CEP, xPais, fone, IE: String): Integer; stdcall; external 'NFPaulista32Dll.dll';
Function Registro20_CAT9807(SerieNFVC, SubSerieNFVC, NumNFVC, DtEm, DtSaida, CPF_CNPJ, Destinatario,
                            Logradouro, Numero, Complemento, Bairro, Municipio, UF,
                            CEP, Telefone, Total_Prod, Total_Desc, Total_Frete, Total_Seguro,
                            Outras_Desp, Desc_Outras_Desp, Total_NFVC, Inter_Contri, Inter_Fisco,
                            Entr_Domic, Logradouro_Entr, Num_Entr, Compl_Entr, Bairro_Entr,
                            Mun_Entr, UF_Entr, Venda_Prazo, A_Vista, Preco_Final,
                            Qnt_Parcelas: String): Integer; stdcall; external 'NFPaulista32Dll.dll';
Function Registro21_CAT9807(Num_Item, Cod_Prod, Tp_Receita, Desc_Merc, Und_Comerc,
                           Qnt, Valor_Unt,Valor_Total : String): Integer; stdcall; external 'NFPaulista32Dll.dll';
Function Registro22_CAT9807(Valor_Parcela, Dt_Venc_Parcela : String): Integer; stdcall; external 'NFPaulista32Dll.dll';
Function Registro30_CAT10207(cProd, xProd, NCM, uCom, qCom, vUnCom, vProd,
                    CST, pICMS, pIPI, vIPI: String): Integer; stdcall; external 'NFPaulista32Dll.dll';
Function Registro40_CAT10207(vBC, vICMS, vBCST, vST, vProd, vFrete, vSeg,
                    vDesc, vIPI, vOutro, vNF, vServ, pISS, vISS: String): Integer; stdcall; external 'NFPaulista32Dll.dll';
Function Registro50_CAT10207(modFrete, CNPJ, xNome, IE, xEnder, xMun, UF, placa, pUF,
                    qVol, esp, marca, nVol, pesoL, pesoB: String): Integer; stdcall; external 'NFPaulista32Dll.dll';
Function Registro60_CAT10207(Fatura, infAdFisco, infCpl: String): Integer; stdcall; external 'NFPaulista32Dll.dll';
Function Registro90_CAT10207: Integer; stdcall; external 'NFPaulista32Dll.dll';
Function Registro90_CAT9807: Integer; stdcall; external 'NFPaulista32Dll.dll';

{$R *.dfm}


procedure TForm1.Trata_NFPaulista_Int(sender: tobject; retorno: integer);
begin
 if retorno = -1 then
  showmessage('Erro na chamada do ' + tbutton(sender).Caption + ', verifique o erro em ' + edit2.text)
 else if retorno = 0 then
  //showmessage('Registro OK, verifique o registro no arquivo de sada em ' + edit1.text)
 else
  showmessage('Retorno desconhecido');
end;

procedure TForm1.Reg10BtnClick(Sender: TObject);
var
 TempInt: integer;
begin
 if Inicia_NF_Paulista(edit1.text, edit2.text) = -1 then
  application.MessageBox('Erro durante chamada da funo Inicia_NFPaulista.',
                         'Ateno', mb_iconerror);

// ABERTURA DO ARQUIVO DIGITAL E IDENTIFICADOR DO ESTABELECIMENTO EMITENTE.

 TempInt := Registro10_CAT10207('1,00',                           //Verso Layout
                                CNPJ,//'34261131000144',                 //CNPJ do emitente
                                '10/10/2007',                     //Data de incio do perodo transferido no arquivo
                                '17/10/2007');                    //Data de fim do perodo transferido no arquivo


 Trata_NFPaulista_Int(sender, TempInt);                  //Trata Retorno da Funo do Registro

 //Se funes do CAT102/07 utilizadas sero, ento s pode usar o outro CAT aps chamar a funo de finaliza
 if TempInt = 0 then    //Retorno OK
  begin
   Reg10_CAT9807.Enabled := false;
   Reg20_CAT9807.Enabled := false;
   Reg21_CAT9807.Enabled := false;
   Reg22_CAT9807.Enabled := false;
   Reg90_CAT9807.Enabled := false;
  end;
end;


procedure TForm1.Reg20BtnClick(Sender: TObject);
var
 TempInt: integer;
begin
 TempInt := Registro20_CAT10207('I',                        //Funo do Registro
                                '',                         //Justificativa do Cancelamento
                                'Venda a Consumidor Final', //Descrio da Natureza da Operao
                                '0',                        //Srie da Nota Fiscal
                                '20956',                    //Nmero da Nota Fiscal
                                '10/10/2007 10:00:00',      //Data de emisso da Nota Fiscal
                                '10/10/2007 10:00:00',      //Data de Sada ou da Entrada da Mercadoria / Produto / Servio
                                '1',                        //Tipo da Nota Fiscal
                                '5102',                     //Cdigo Fiscal de Operaes e Prestaes
                                '000000000000',             //IE do Substituto Tributrio na UF de destino
                                '000000000000',             //Inscrio Municipal do Emitente
                                CNPJ,                       //CNPJ ou CPF do destinatrio
                                'Casa F',                   //Razo Social ou nome do destinatrio
                                'R So Manoel',             //Logradouro
                                '176',                      //Nmero
                                'apto 18',                  //Complemento
                                'Centro',                   //Bairro
                                'So Paulo',                //Nome do municpio
                                'SP',                       //Sigla da UF
                                '10100000',                 //Cdigo do CEP
                                'Brasil',                   //Nome do Pas
                                '5550723',                  //Telefone
                                '');                        //IE do Destinatrio

 Trata_NFPaulista_Int(sender, TempInt);            //Trata Retorno da Funo do Registro
end;

procedure TForm1.Reg30BtnClick(Sender: TObject);
var
 TempInt: Integer;
begin
 TempInt := Registro30_CAT10207('Produto 0',                //Cdigo do produto ou servio
                                'Pinga tipo 0',             //Descrio do produto ou servio
                                '22060090',                 //Cdigo NCM
                                'caixa',                    //Unidade Comercial
                                '1,0000',                   //Quantidade Comercial
                                '5,0000',                   //Valor Unitrio de comercializao
                                '5,00',                     //Valor Total Bruto dos Produtos ou Servios
                                '010',                      //Cdigo da Situao Tributria
                                '18,00',                    //Alquota do imposto ICMS
                                '6,00',                     //Alquota do IPI
                                '10,00');                   //Valor do IPI

 Trata_NFPaulista_Int(sender, TempInt);            //Trata Retorno da Funo do Registro
end;

procedure TForm1.Reg40BtnClick(Sender: TObject);
var
 TempInt: Integer;
begin
 TempInt := Registro40_CAT10207('69,01',                    //Base de Clculo do ICMS
                                '1234,56',                  //Valor Total do ICMS
                                '45,78',                    //Base de Clculo do ICMS ST
                                '123,45',                   //Valor Total do ICMS ST
                                '100,10',                   //Valor Total dos produtos e servios
                                '20,02',                    //Valor Total do Frete
                                '10,01',                    //Valor Total do Seguro
                                '30,00',                    //Valor Total do Desconto
                                '5,00',                     //Valor Total do IPI
                                '1,00',                     //Outras Despesas acessrias
                                '229,58',                   //Valor Total da NF
                                '234,00',                   //Valor Total dos Servios sob no-incidncia ou no tributados pelo ICMS
                                '6,00',                     //Alquota do ISS
                                '154,00');                  //Valor Total do ISS

 Trata_NFPaulista_Int(sender, TempInt);            //Trata Retorno da Funo do Registro
end;

procedure TForm1.Reg50BtnClick(Sender: TObject);
var
 TempInt: Integer;
begin
 TempInt := Registro50_CAT10207('0',                        //Modalidade do frete
                                CNPJ,                       //CNPJ ou CPF
                                'Transportadora Xing Ling', //Razo Social ou nome
                                '000000000000',             //Inscrio Estadual
                                'Av. da Lentidao, 321',     //Endereo Completo
                                'Sao Paulo',                //Nome do municpio
                                'SP',                       //Sigla da UF
                                'ABC1234',                  //Placa do Veculo
                                'SP',                       //Sigla da UF da Placa
                                '123456789012345',          //Quantidade de volumes transportados
                                'litros',                   //Espcie dos volumes transportados
                                'Xing Ling',                //Marca dos volumes transportados
                                '123456789',                //Numerao dos volumes transportados
                                '123,000',                  //Peso Lquido (em kg)
                                '154,064');                 //Peso Bruto (em kg)

 Trata_NFPaulista_Int(sender, TempInt);            //Trata Retorno da Funo do Registro
end;

procedure TForm1.Reg60BtnClick(Sender: TObject);
var
 TempInt: Integer;
begin
 TempInt := Registro60_CAT10207('Dados da fatura',                                          //Dados da Fatura
                       'Informacoes adicionais de interesse do Fisco',             //Informaes Adicionais de Interesse do Fisco
                       'Informacoes complementares de interesse do contribuinte'); //Informaes Complementares de interesse do Contribuinte

 Trata_NFPaulista_Int(sender, TempInt);
end;

procedure TForm1.Reg90BtnClick(Sender: TObject);
var
 TempInt: Integer;
begin
 //--- Registro90 - ENCERRAMENTO DO ARQUIVO DIGITAL ---
 TempInt := Registro90_CAT10207;

 Trata_NFPaulista_Int(sender, TempInt);

 Finaliza_NF_Paulista;

 Reg10_CAT9807.Enabled := true;
 Reg20_CAT9807.Enabled := true;
 Reg21_CAT9807.Enabled := true;
 Reg22_CAT9807.Enabled := true;
 Reg90_CAT9807.Enabled := true;

 ShowMessage('Verifique os arquivo de sada em ' + edit1.text);
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
opendialog1.InitialDir := extractfilepath(application.exename);
if opendialog1.Execute then
 edit1.Text := opendialog1.FileName;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
 opendialog1.InitialDir := extractfilepath(application.exename);

if opendialog1.Execute then
 edit2.Text := opendialog1.FileName;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
 edit1.Text := ExtractFileDrive(application.ExeName) + '\';
 edit2.Text := extractfiledir(application.ExeName);
end;

procedure TForm1.Sequencia10_20_30_40_50_60_90Click(Sender: TObject);
begin
 Reg10Btn.Click;  //Registro10_CAT10207
 Reg20Btn.Click;  //Registro20_CAT10207
 Reg30Btn.Click;  //Registro30_CAT10207
 Reg40Btn.Click;  //Registro40_CAT10207
 Reg60Btn.Click;  //Registro60_CAT10207
 Reg90Btn.Click;  //Registro90_CAT10207
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 Action := CAFree;
end;

procedure TForm1.SairBtnClick(Sender: TObject);
begin
 Self.Close;
end;

procedure TForm1.Reg10_CAT9807Click(Sender: TObject);
begin
 if Inicia_NF_Paulista(edit1.text, edit2.text) = -1 then
  application.MessageBox('Erro durante chamada da funo Inicia_NFPaulista.',
                         'Ateno', mb_iconerror);

// ABERTURA DO ARQUIVO DIGITAL E IDENTIFICADOR DO ESTABELECIMENTO EMITENTE.

 //A estrutura do registro 10  a mesma para os CAT102/07 e CAT98/07
 TempInt := Registro10_CAT10207('1,00',                           //Verso Layout
                                CNPJ,                             //CNPJ do emitente
                                '10/10/2007',                     //Data de incio do perodo transferido no arquivo
                                '17/10/2007');                    //Data de fim do perodo transferido no arquivo


 Trata_NFPaulista_Int(sender, TempInt);                  //Trata Retorno da Funo do Registro

 //Se funes do CAT98/07 utilizadas sero, ento s pode usar o outro CAT aps chamar a funo de finaliza
 if TempInt = 0 then    //Retorno OK
  begin
   Reg10Btn.Enabled := false;
   Reg20Btn.Enabled := false;
   Reg30Btn.Enabled := false;
   Reg40Btn.Enabled := false;
   Reg50Btn.Enabled := false;
   Reg60Btn.Enabled := false;
   Reg90Btn.Enabled := false;
  end;
end;

procedure TForm1.Reg20_CAT9807Click(Sender: TObject);
var
 TempInt: integer;
begin
 TempInt := Registro20_CAT9807('1',                                   //Srie da NFVC
                               '123456',                              //Subsrie da NFVC
                               '123456789',                           //Nmero da NFVC
                               '10/10/1984',                          //Data de emisso
                               '10/10/1984',                          //Data da sada
                               CNPJ,                                  //CPF ou CNPJ do Destinatrio
                               'TKS Software',                        //Nome do destinatrio
                               'Rua Padre Casemiro Quiroga',          //Logradouro
                               '123',                                 //Nmero
                               'Centro Comercial do Imbui - Loja D',  //Complemento
                               'Imbui',                               //Bairro/Distrito
                               'Salvador',                            //Municpio
                               'BA',                                  //UF
                               '41720050',                            //CEP
                               '33711818',                            //Telefone
                               '15,00',                               //Valor total dos produtos
                               '0,00',                                //Valor total do desconto
                               '0,00',                                //Valor total do frete
                               '0,00',                                //Valor total do seguro
                               '0,00',                                //Outras despesas acessrias
                               'Texto Livre',                         //Descrio das outras despesas acessrias
                               '15,00',                               //Valor Total da NFVC - Deve corresponder ao resultado do clculo: valores totais dos produtos + frete + seguro + outras despesas acessrias - descontos.
                               'Texto Livre',                         //Informaes complementares do interesse do contribuinte
                               'Texto Livre',                         //Informaes complementares de interesse do fisco
                               '2',                                   //Realiza entrega em domiclio
                               '',                                    //Logradouro do local de entrega
                               '',                                    //Nmero do local de entrega
                               '',                                    //Complemento do local de entrega
                               '',                                    //Bairro/Distrito do local de entrega
                               '',                                    //Municpio do local de entrega
                               '',                                    //UF do local de entrega
                               '2',                                   //Realiza venda a prazo
                               '15,00',                               //Preo  vista
                               '15,00',                               //Preo final
                               '0');                                  //Quantidade de parcelas nas vendas a prazo

 Trata_NFPaulista_Int(sender, TempInt);            //Trata Retorno da Funo do Registro
end;

procedure TForm1.Reg21_CAT9807Click(Sender: TObject);
var
 TempInt: integer;
begin
 TempInt := Registro21_CAT9807('1',                                   //Nmero do Item
                               '123456',                              //Cdigo do produto
                               '1',                                   //Tipo de receita
                               'Descricao da mercadoria',             //Descrio da mercadoria
                               'Kg',                                  //Unidade de comercializao
                               '1,00',                                //Quantidade
                               '1,00',                                //Valor Unitrio
                               '1,00');                               //Valor Total

 Trata_NFPaulista_Int(sender, TempInt);            //Trata Retorno da Funo do Registro
end;

procedure TForm1.Reg22_CAT9807Click(Sender: TObject);
var
 TempInt: integer;
begin
 TempInt := Registro22_CAT9807('1,00',                                //Valor da parcela
                               '12/02/2008');                         //Data de vencimento da parcela

 Trata_NFPaulista_Int(sender, TempInt);            //Trata Retorno da Funo do Registro
end;

procedure TForm1.Reg90_CAT9807Click(Sender: TObject);
var
 TempInt: Integer;
begin
 //--- Registro90 - ENCERRAMENTO DO ARQUIVO DIGITAL ---
 TempInt := Registro90_CAT9807;

 Trata_NFPaulista_Int(sender, TempInt);

 Finaliza_NF_Paulista; 

 Reg10Btn.Enabled := true;
 Reg20Btn.Enabled := true;
 Reg30Btn.Enabled := true;
 Reg40Btn.Enabled := true;
 Reg50Btn.Enabled := true;
 Reg60Btn.Enabled := true;
 Reg90Btn.Enabled := true;
end;

end.
